********************************************************************
*                       DFLIP.S                                    *
*          Program to flip the grob diagonally                     *
*                   By Robert Tiismus                              *
*                  robert@physic.ut.ee                             *
*                                                                  *
*              Last change: October 1998                           *
*                                                                  *
*  In: Original GROB                                               *
* Out: Diagonally flipped grob.                                    *
********************************************************************

ASSEMBLE
BA      EQU     0
DA      EQU     1
RPL
::
 CK1&Dispatch grob
 ::
  CODE
	GOSBVL  =SAVPTR
	GOSBVL  =DisableIntr

	C=DAT1  A
	D0=C            D0 -> GROB prolog
	D1=C            D1 -> GROB prolog

	D1=D1+  5       Test for NULL GROB
	C=DAT1  A
	B=C     A
	D0=D0+  10      D0 -> #Y dim
	D1=D1+  10      D1 -> #X dim

	C=DAT0  A       C=#Y dim
	A=DAT1  A       A=#X dim

	B=B-CON A,16
	GONC    +       Not NULL GROB

********* Null Grob ***********

	DAT0=A  A       Exchange the dimensions X & Y
	DAT1=C  A
	GOTO    ++      Finito

*******************************

+       R0=C.F  A       R0.A=#Y dim Goes to #X dim
	R1=A.F  A       R1.A=#X dim Goes to #Y dim

	A=A+CON A,7     Expand A to full byte pixels
	ASRB.F  A       and reduce to nib's count
	ASRB.F  A
	ABIT=0  0
	R4=A.F  A       R4.A=Number of nibble rows

	GOSBVL  =makegrob       D0 -> New GROB body
	CD0EX
	C=C-CON A,16
	C=C-CON A,4
	B=C     A       B.A -> New GROB header

	GOSBVL  =D1=DSKTOP      Get pointer to old GROB prolog from stack,
	A=DAT1  A               A -> Old GROB header
	C=B     A               and
	DAT1=C  A       replace Old GROB on stack with new one

	A=A+CON A,16
	A=A+CON A,4
	R2=A.F  A       R2.A -> Old GROB body

	D0=C            D0 -> New GROB header
	D0=D0+  10
	A=DAT0  A
	C=R4.F  A
	B=C     A       B=height of new GROB in nibs'

	C=C+C   A       Is one nibble row at the bottom unneeded?
	C=C+C   A
	C=C-A   A
	P=C     0
	C=P     15
	ST=0    BA
	P=      15
	LAHEX   4
	?C<A    S
	GOYES   +

	C=C-A   S
	ST=1    BA
*                       C.S=Reduntant rows
+       C=A-C   S       Take one nibble off the bottom
	C=C-1   S       C.S=Pixel rows to write on last nibble row - 1

	D0=D0+  5
	C=DAT0  A       C.A=Width of new GROB
	C=C+CON A,7     Compute the width in nibs
	CSRB.F  A
	CSRB.F  A

	?CBIT=1 0
	GOYES   +
+       CBIT=0  0
	ST=0    DA
	GOC     +
	ST=1    DA      Do not flip the 'owerborder' nib
+       D=C     A       D=width of new GROB in nibs'

	D0=D0+  5       D0 -> New GROB body
	CD0EX
	R3=C.F  A       R3.F -> New GROB body

*      D=orig rows in nibs
*      B=orig columns in nibs
*      R2->orig grob body
*      R3->new grob body
*      C.S->pixel rows to write on last nibble row - 1

	C=D     A
	?ST=0   DA
	GOYES   +
	C=C-1   A
+       C=C-1   A
	RSTK=C          RSTK 0 = Orig Rows counter

NXTROW  C=R2.F  A
	R0=C.F  A       R0 -> Running position in orig GROB
	C=R3.F  A
	R1=C.F  A       R1 -> Running position in new GROB

	C=B     A
	?ST=0   BA
	GOYES   +
	C=C-1   A
+       C=C-CON A,2     Count one column less than needed (to detect last col)
	GOC     DFLROW  Only one column?
	RSTK=C          RSTK 1 = Orig Columns Counter

NXTCOL  C=R0.F  A
	D0=C            D0 -> running pos in orig GROB
	C=R1.F  A
	D1=C            D1 -> running pos in new GROB

	P=      3       Read nib^2 from orig GROB into A.4
-       A=DAT0  P
	AD0EX
	A=A+B   A
	AD0EX
	P=P-1
	GONC    -
	P=      0

	GOSUB   flipnib         Flip the read nib^2 A.16->C.16

	P=      3       Write nib^2 to new GROB from C.4
-       DAT1=C  P
	CD1EX
	C=C+D   A
	CD1EX
	P=P-1
	GONC    -

*****************

	C=R0.F  A       Adwance Orig GROB position pointer
	C=C+1   A       to one position right
	R0=C.F  A

	A=R1.F  A       Adwance New GROB position pointer
	C=D     A       to one position down
	C=C+C   A
	C=C+C   A
	A=A+C   A
	R1=A.F  A

	C=RSTK          Adwance Columns counter
	C=C-1   A
	RSTK=C

	GOC     +
	GOTO    NXTCOL

***************************************************

+       C=RSTK          Pop unneccesary stack level

** Process the last row on the new GROB **

DFLROW  C=R0.F  A
	D0=C            D0 -> running pos in orig GROB
	C=R1.F  A
	D1=C            D1 -> running pos in new GROB

	P=      3       Read nib^2 from orig GROB into A.4
-       A=DAT0  P
	AD0EX
	A=A+B   A
	AD0EX
	P=P-1
	GONC    -
	P=      0

	GOSUB   flipnib         Flip the read nib^2

	A=C     S
	P=      3       Write nib^2 to new GROB from C.4
-       DAT1=C  P
	CD1EX
	C=C+D   A
	CD1EX
	P=P-1
	A=A-1   S
	GONC    -

**************************************************

	C=R3.F  A       Adwance New GROB column to
	C=C+1   A       one position right
	R3=C.F  A

	A=R2.F  A       Adwance Old GROB row
	C=B     A       to one position down
	C=C+C   A
	C=C+C   A
	A=A+C   A
	R2=A.F  A

	C=RSTK          Adwance Rows counter
	C=C-1   A
	RSTK=C

	GOC     +
	GOTO    NXTROW

**********************

+       C=RSTK          Pop unneccesary stack level
	P=      0

++      GOSBVL  =AllowIntr
	GOVLNG  =GETPTRLOOP

*+++++++++++++++++++++++++++++++++++++++++++++++++*

***************************************************
* Flip the bits in nib^2                          *
*                                                 *
*  In: A.0...A.15                                 *
* Out: C.0...C.15                                 *
***************************************************

flipnib

*     +-------------+   We have to flip on 3-12 diagonal, because
*     | 15 14 13 12 |   bits are in small endian form in GROB object
*     | 11 10  9  8 |
*     |  7  6  5  4 |
*     |  3  2  1  0 |
*     +-------------+

	LCHEX   1248    Copy pixels on diagonal into C.4
	C=C&A   A       Bits 3, 6, 9 and 12

	?ABIT=0 0       0 -> 15
	GOYES   +
	CBIT=1  15

+       ?ABIT=0 1       1 -> 11
	GOYES   +
	CBIT=1  11

+       ?ABIT=0 2       2 -> 7
	GOYES   +
	CBIT=1  7

+       ?ABIT=0 4       4 -> 14
	GOYES   +
	CBIT=1  14

+       ?ABIT=0 5       5 -> 10
	GOYES   +
	CBIT=1  10

+       ?ABIT=0 7       7 -> 2
	GOYES   +
	CBIT=1  2

+       ?ABIT=0 8       8 -> 13
	GOYES   +
	CBIT=1  13

+       ?ABIT=0 10      10 -> 5
	GOYES   +
	CBIT=1  5

+       ?ABIT=0 11      11 -> 1
	GOYES   +
	CBIT=1  1

+       ?ABIT=0 13      13 -> 8
	GOYES   +
	CBIT=1  8

+       ?ABIT=0 14      14 -> 4
	GOYES   +
	CBIT=1  4

+       ?ABIT=0 15      15 -> 0
	GOYES   +
	CBIT=1  0

+       RTN

  ENDCODE
 ;
;
